#include <STC32G.H>
#include "intrins.h"
#include "stc.h"
#include "ADC.h"

u16 ADC_Value_INT;
u16 BGV=0; 

#define ADC_Function 1   
/* #define ADC_Function x (xȡ0,1,2)  ֱ3ֲͬĹ
	x==0ʱΪ  ѡADCͨ 12λADCת   ѯʽ
	x==1ʱͬ ˹ʹжϣִж жϷʽ
	x==2ʱADC15ͨ ADC-Vref+ ѹ (صѹ)
	
*/

#if ADC_Function == 0

void ADC_Init(void)
{
    P1M0 = 0x00; 
	P1M1 = 0x08;  //P10λ 
	
	ADC_POWER=1;  //ADCԴ
	ADCTIM=0X3F;  //ADCʱ
	ADCCFG=0X2F;  //ADCתΪҶ ADCʱΪ
}

u16 ADC_Read(u8 Channel)
{
	u16 ADC_Value;
	ADC_CONTR &=0XE0;
	ADC_CONTR |=Channel;
	
	ADC_START=1;
	_nop_();	
	_nop_();		//ָ   ãӳһʱ
	while(!ADC_FLAG);
	ADC_FLAG=0;
	ADC_Value= (ADC_RES<<8) + ADC_RESL;
	
	return ADC_Value;
}

#elif ADC_Function ==1

void ADC_Init(void)   //
{
    P1M0 = 0x00; 
	P1M1 = 0x08;  //P13λ 
	ADC_CONTR &=0XE0;  //ѡͨ
	ADC_CONTR |=0X03;
	
	ADC_POWER=1;  //ADCԴ
	ADCTIM=0X3F;  //ADCʱ
	ADCCFG=0X2F;  //ADCתΪҶ ADCʱΪ
	EADC=1;
	ADC_START=1;
}

void ADC_Isr(void) interrupt 5
{
	ADC_FLAG=0;
	ADC_Value_INT= (ADC_RES<<8) + ADC_RESL;
	ADC_START=1;
}

#elif ADC_Function ==2

#define VREFH_ADDR CHIPID7
#define VREFL_ADDR CHIPID8   //ڲ 1.19V οźԴ-BGV

void ADC_Init(void)
{
	ADC_POWER=1;  //ADCԴ
	ADCTIM=0X3F;  //ADCʱ
	ADCCFG=0X2F;  //ADCתΪҶ ADCʱΪ
}

u16 ADC_Read(u8 Channel)
{
	u16 ADC_Value;
	ADC_CONTR &=0XF0;
	ADC_CONTR |=Channel;
	
	ADC_START=1;
	_nop_();	
	_nop_();		//ָ   ãӳһʱ
	while(!ADC_FLAG);
	ADC_FLAG=0;
	ADC_Value= (ADC_RES<<8) + ADC_RESL;
	
	return ADC_Value;
}

u16 ADC_CalVref(void)
{
	
	u8 i=0;
	u16 Res=0;
	u16 VCC=0;
	
	BGV = (VREFH_ADDR<<8) + VREFL_ADDR;  //ȡڲ1.19VοźԴ

	ADC_Read(15);  //ֱд15ԭ:ʽΪchar ʮƵ15 ɶƺΪ 0000 1111
	ADC_Read(15);
	ADC_Read(15);  //ֲὨǰ2ݶﶪ3(ն3)  ǰݻԲص
	for(i=0;i<8;i++)
	{
		Res+=ADC_Read(15);
	}
	Res >>= 3;   //3λ൱ڳ8
	VCC = (int)(4096L * BGV / Res);   //Lʾóóͷʽ洢,൱long
	return VCC;
}


#else

#endif

u16 ADC_CalVoltage(u16 ADC_Num)
{
	return ADC_Num*2.5*1000/4096;
}


#define ADC_OFFSET 64
u8 ADC_KeyRead(u16 ADC_Value)
{
	u8 i;
	u16 ADC_Compare=256;
	static u8 KeyState_former=0;
	static u16 Key_Downtime=0;
	
	if( ( ADC_Value < ( ADC_Compare - ADC_OFFSET) ) || ( ADC_Value > ( 4096 + ADC_OFFSET) ) )
	{
		//return 0;
		Key_Downtime=0;
		KeyState_former=0;
	}
	else
	{
		for(i=1;i<=16;i++)
		{
			if( ADC_Value >= ( ADC_Compare*i - ADC_OFFSET) && ADC_Value <= ( ADC_Compare*i + ADC_OFFSET))
			{
				//return i;   //µڼضӦ
				break;
			}
			
		}
		
		if(KeyState_former==i)  //Ҳ𵽰
		{
			Key_Downtime++;
			if(Key_Downtime==3)  //10ms*3 ̰ 
			{
				return i;
			}
			else if(Key_Downtime==200)   //10ms*200ᴥ ⳤ 𵽳 
			{
				Key_Downtime=190;  //ÿ 10ms*15 
				return i;
			}
		}
		else
		{
			Key_Downtime=0;
			KeyState_former=i;
		}
	
	
	}	
	return 0;
}
